import java.util.*;

public class DerivativeFinder
{
	private String classString; //the eqquation ehose derivative is to be calcuated
	private Vector<String>stringTokens;

	public DerivativeFinder(String s)
	{
		classString = s.trim();

		StringToVectorTokenizer stv = new StringToVectorTokenizer(s);
		stringTokens = stv.tokenizeToVector();


	}//public derivativeFinder(s)

	//the following function answe fix adjust  the answer if it has term multiplied
	// or added to 0. ((ln((x-3)))*(0)))--> ((0))
	static String answerFix(String s)
	{
		String temp = s;
		int g=0;
		while(g<s.length())
		{
			if(((s.length()>=4)&&s.substring(g, g+4).equals("+(0)"))||
			      ((s.length()>=4)&&s.substring(g, g+4).equals("-(0)")))
			{
				String one = s.substring(0,g);
				String two= s.substring(g+4);
				return one.concat(two);

			}
			else if((s.length()>=5)&&s.substring(g, g+5).equals("*(0))"))
			{
				int counter=-1;
				for(int l=g-1; l>=0;l--)
				{
					if(s.charAt(l)==')')counter--;
					else if(s.charAt(l)=='(')counter++;
					else{}

					if(counter==0)
					{
						String one = s.substring(0,l).concat("(0)");
						String two= s.substring(g+5);
						return one.concat(two);
					}
				}
			}

			g++;
		}
		return s;
	}//answerFix

	static  boolean isOperator(String s)
	//return true if s is an operator
	{
	    if     ( s.equalsIgnoreCase(new String(")"))) return true;
	    else if( s.equalsIgnoreCase(new String("+"))) return true;
	    else if( s.equalsIgnoreCase(new String("-"))) return true;
	    else if( s.equalsIgnoreCase(new String("*"))) return true;
	    else if( s.equalsIgnoreCase(new String("/"))) return true;
	    else if( s.equalsIgnoreCase(new String("^"))) return true;
	    else if( s.equalsIgnoreCase(new String("("))) return true;
	    else                                          return false;
	}//isOperator

	static boolean isOperator2(String s)
	//return true for sin, cos, tan, cot, sec.
	{
	      if      (s.equalsIgnoreCase(new String("sin")))return  true;
	      else if (s.equalsIgnoreCase(new String("cos")))return  true;
	      else if (s.equalsIgnoreCase(new String("tan")))return  true;
	      else if (s.equalsIgnoreCase(new String("cot")))return  true;
	      else if (s.equalsIgnoreCase(new String("sec")))return  true;
	      else if (s.equalsIgnoreCase(new String("csc")))return  true;
	      else if (s.equalsIgnoreCase(new String("log")))return  true;
	      else if (s.equalsIgnoreCase(new String("exp")))return  true;
	      else                                           return false;
	}//isOprator2()

	static boolean isOperator3(String s)
	//return true for ln
	{
	      if      (s.equalsIgnoreCase(new String("ln"))) return  true;
	      else                                           return false;
	}//isOprator3()

	static boolean isOperator4(String s)
	//return true for sqrt, asin, acos,  atan
	{
	    if      (s.equalsIgnoreCase(new String("asin")))return  true;
	      else if (s.equalsIgnoreCase(new String("acos")))return  true;
	      else if (s.equalsIgnoreCase(new String("atan")))return  true;
	      else if (s.equalsIgnoreCase(new String("acot")))return  true;
	      else if (s.equalsIgnoreCase(new String("asec")))return  true;
	      else if (s.equalsIgnoreCase(new String("acsc")))return  true;
	      else if (s.equalsIgnoreCase(new String("sqrt")))return  true;
	      else                                            return false;
	}//isOprator4()

	static boolean isNumber(char s)
	//return true for numbers
	{
	      boolean returnValue=true;
        { if (s !='.' && s !='0' && s !='1' && s !='2' && s !='3' && s !='4' && s !='5' &&
		                 s !='6' && s !='7' && s !='8' && s !='9'&& s !='x'&& s !='X' )
		  returnValue = false;
	    }
	      return returnValue;
	}//isnumber()

	static boolean isPNumber(String s)
	{ s.trim();
	      boolean returnValue = true;
	      for(int i =0;i<s.length();i++)
		  {
			 if(!isNumber(s.charAt(i))) returnValue=false;
		  }


		  return returnValue;
	}

    static boolean isNNumber(String s)
	{ s.trim();
		  if(s.charAt(0)=='-'&& isPNumber(s.substring(1)))return true;
		  else return false;

	}

    static boolean isNumber(String s)
    {
			if(isNNumber(s)||isPNumber(s)) return  true;
			else return false;
	}

/**
   The folowing function (vectorAdjust) is added to adjust the vector comming
   from class String to vector tokenizer
   it adjust equation like -sin.., -(...),... to (-1)*sin..,...
   this will enable the Evaluate function in the Equation class
   to correctly parse the expression to evaluate it
   */
  static Vector<String> vectorAdjust(Vector<String> vec)
  {
	  Vector<String> v =new Vector<String>();
	  v.add("(");  v.add("-1"); v.add(")"); v.add("*");
	  if(vec.get(0).equals("-"))
	  {
		  //if the leading character is a negative sine"-", replace it with "(-1)*"
		  vec.removeElementAt(0);  vec.addAll(0,v);
		  return vec;

	  }
	  else{
		  for(int i=0;i<vec.size()-2; i++)
	      {
			  if(vec.get(i).equals("(")&&vec.get(i+1).equals("-"))
			  {
				  //if ( is followed by - change - to "(0-1)*"
				  vec.removeElementAt(i+1);  vec.addAll(i+1,v);
				  return vec;
			  }
			  else{}
	      }
	      return vec;
	  }//else
  }

	public void print_stringTokens()
	{
	      System.out.print("\n");
	      for(int i=0; i<stringTokens.size()-1; i++)
	      System.out.print(stringTokens.get(i) +", " );
	      System.out.print(stringTokens.lastElement() +"\n");
	}


	public String get_equation_String()
	{
	       return classString;
	}


	public Vector<String>  get_stringTokens()
	{
	      return stringTokens;
    }

	public static void printVector(Vector<String> vec)
	{
	     System.out.print("\n");
	      for(int i=0; i<vec.size()-1; i++)
	      System.out.print(vec.get(i) +", " );
	      System.out.print(vec.lastElement() +"\n");
	}
	public static Vector<String> getVectorFrom(Vector<String> vec, int from, int until)
	{//return another vector which is a part of the current vector
	   //bound from "from"index to "untill" index
		  Vector<String>temp = new Vector<String> ();
		  for(int i = from; i<=until;i++)
		  {
			  temp.addElement(vec.get(i));
		  }
		  return temp;
	}

	public static String vectorToString(Vector<String> vec)
	{
		  String s = "";
		  for(int i=0; i<vec.size(); i++)
		   s=s.concat(vec.get(i));
		  return s;
    }
	/**
	**/
    static public  String findDerivative(Vector<String> vec)//find derivative of class string located in class vector
    {
		Vector<String> vector = vectorAdjust(vec);
		if(vector.get(0).equals("(")&&vector.lastElement().equals(")"))
		{
			 //removing the frame (......) or((..)(..))but not the one like (..)(..)
			 //by cheking inside the frame if ) is found befor ( or not
			 int j=0; //bracket open and close counter
			 boolean bracket = true;
			 for(int k=1; k<vector.size()-1;k++)
			 {
				 if(vector.get(k).equals("("))j+=1;
				 else if(vector.get(k).equals(")"))j-=1;
				 else{}
				 if(j<0) bracket = false;
			 }
			 if(bracket)return findDerivative(getVectorFrom(vector, 1, vector.size()-2));
			 else{}
		}

		if(vector.size()==0)
		{
			String ret = "there is no equation to differentiate."; return ret;
		}
     	else if(vector.size()==1)//expression is X or constant number
		{
			 if(vector.get(0).equalsIgnoreCase("x")) return "1";
			 else if(vector.get(0).equalsIgnoreCase("-x")) return "-1";
			 else if(isNumber(vector.get(0))) return "0";
			 else if(vector.get(0).equalsIgnoreCase("e")||vector.get(0).equalsIgnoreCase("-e")) return "0";
			 else if(vector.get(0).equalsIgnoreCase("pi")||vector.get(0).equalsIgnoreCase("-pi")) return "0";
			 else{return "expression not suported";}
		}
		else if(vector.size()==2)//sinX, sqrtX, sin30, cos -x,...
		{
			 if(vector.get(0).equalsIgnoreCase("sin")&& vector.get(1).equalsIgnoreCase("x")) return "(cos x)";
			 else if(vector.get(0).equalsIgnoreCase("sin")&& vector.get(1).equalsIgnoreCase("-x")) return "(-cos -x)";
			 else if(vector.get(0).equalsIgnoreCase("sin")&& isNumber(vector.get(1))) return "0";

			 else if(vector.get(0).equalsIgnoreCase("cos")&& vector.get(1).equalsIgnoreCase("x")) return "(-sin x)";
			 else if(vector.get(0).equalsIgnoreCase("cos")&& vector.get(1).equalsIgnoreCase("-x")) return "(sin -x)";
			 else if(vector.get(0).equalsIgnoreCase("cos")&& isNumber(vector.get(1))) return "0";

			 else if(vector.get(0).equalsIgnoreCase("tan")&& vector.get(1).equalsIgnoreCase("x")) return "((sec x)^2)";
	         else if(vector.get(0).equalsIgnoreCase("tan")&& vector.get(1).equalsIgnoreCase("-x")) return "(-(sec -x)^2)";
			 else if(vector.get(0).equalsIgnoreCase("tan")&& isNumber(vector.get(1))) return "0";

			 else if(vector.get(0).equalsIgnoreCase("sec")&& vector.get(1).equalsIgnoreCase("x")) return "((sec x)*(tan x))";
			 else if(vector.get(0).equalsIgnoreCase("sec")&& vector.get(1).equalsIgnoreCase("-x")) return "(-(sec -x)*(tan -x))";
			 else if(vector.get(0).equalsIgnoreCase("sec")&& isNumber(vector.get(1))) return "0";

			 else if(vector.get(0).equalsIgnoreCase("csc")&& vector.get(1).equalsIgnoreCase("x")) return "(-(csc x)*(cot x))";
			 else if(vector.get(0).equalsIgnoreCase("csc")&& vector.get(1).equalsIgnoreCase("-x")) return "((csc -x)*(cot -x))";
			 else if(vector.get(0).equalsIgnoreCase("csc")&& isNumber(vector.get(1))) return "0";

			 else if(vector.get(0).equalsIgnoreCase("cot")&& vector.get(1).equalsIgnoreCase("x")) return "(-(csc x)^2)";
			 else if(vector.get(0).equalsIgnoreCase("cot")&& vector.get(1).equalsIgnoreCase("-x")) return "((csc x)^2)";
			 else if(vector.get(0).equalsIgnoreCase("cot")&& isNumber(vector.get(1))) return "0";

			 else if(vector.get(0).equalsIgnoreCase("asin")&& vector.get(1).equalsIgnoreCase("x")) return "(1/sqrt(1-(x^2)))";
			 else if(vector.get(0).equalsIgnoreCase("asin")&& vector.get(1).equalsIgnoreCase("-x")) return "(-1/sqrt(1-(x^2)))";
			 else if(vector.get(0).equalsIgnoreCase("asin")&& isNumber(vector.get(1))) return "0";

		     else if(vector.get(0).equalsIgnoreCase("acos")&& vector.get(1).equalsIgnoreCase("x")) return "(-1/sqrt(1-(x^2)))";
			 else if(vector.get(0).equalsIgnoreCase("acos")&& vector.get(1).equalsIgnoreCase("-x")) return "(1/sqrt(1-(x^2)))";
			 else if(vector.get(0).equalsIgnoreCase("acos")&& isNumber(vector.get(1))) return "0";

			 else if(vector.get(0).equalsIgnoreCase("atan")&& vector.get(1).equalsIgnoreCase("x")) return "(1/(1+(x^2)))";
			 else if(vector.get(0).equalsIgnoreCase("atan")&& vector.get(1).equalsIgnoreCase("-x")) return "(-1/(1+(x^2)))";
			 else if(vector.get(0).equalsIgnoreCase("atan")&& isNumber(vector.get(1))) return "0";

			 else if(vector.get(0).equalsIgnoreCase("asec")&& vector.get(1).equalsIgnoreCase("x")) return "(1/(x*sqrt((x^2)-1)))";
	         else if(vector.get(0).equalsIgnoreCase("asec")&& vector.get(1).equalsIgnoreCase("-x")) return "(-1/(x*sqrt((x^2)-1)))";
			 else if(vector.get(0).equalsIgnoreCase("asec")&& isNumber(vector.get(1))) return "0";

			 else if(vector.get(0).equalsIgnoreCase("exp")&& vector.get(1).equalsIgnoreCase("x")) return "(expx)";
			 else if(vector.get(0).equalsIgnoreCase("exp")&& vector.get(1).equalsIgnoreCase("-x")) return "(-exp(-x))";
			 else if(vector.get(0).equalsIgnoreCase("exp")&& isNumber(vector.get(1))) return "0";

			 else if(vector.get(0).equalsIgnoreCase("ln")&& vector.get(1).equalsIgnoreCase("x")) return "(1/x)";
			 else if(vector.get(0).equalsIgnoreCase("ln")&& vector.get(1).equalsIgnoreCase("-x")) return "(1/x)";
			 else if(vector.get(0).equalsIgnoreCase("ln")&& isNumber(vector.get(1))) return "0";

			 else if(vector.get(0).equalsIgnoreCase("log")&& vector.get(1).equalsIgnoreCase("x")) return "(1/(x*ln(10)))";
			 else if(vector.get(0).equalsIgnoreCase("log")&& vector.get(1).equalsIgnoreCase("-x")) return "(1/(x*ln(10)))";
			 else if(vector.get(0).equalsIgnoreCase("log")&& isNumber(vector.get(1))) return "0";

			 else if(vector.get(0).equalsIgnoreCase("sqrt")&& vector.get(1).equalsIgnoreCase("x")) return "(1/(2*sqrtx))";
			 //sqrt is not defined or -ve
			 else if(vector.get(0).equalsIgnoreCase("sqrt")&& isNumber(vector.get(1))) return "0";

			 else{return "expression not suported";}
		}

		else //recursive cals
		{
			boolean state=true;  //for +,-
			boolean state2=true; //for *,/
			boolean state3=true; //for ^
			boolean state4=true; //for sin cos,exp,....
			int i=0;//bracket tracer
			int k = 0;//while terminator
			while(state)
			{
				if(vector.get(k).equals("(")){ i+=1; k+=1;}
				else if(vector.get(k).equals(")")) {i-=1; k+=1;}
				else if(vector.get(k).equals("+")&& i==0)//...+...
				{
					state2=false; //block the next while block
					state3=false; state4=false;
					String s= findDerivative(getVectorFrom(vector, 0, k-1)).concat("+").concat
					         (findDerivative(getVectorFrom(vector, k+1, vector.size()-1)) );
					return "(".concat(s).concat(")");

				}
				else if(vector.get(k).equals("-")&& i==0)//...-...
				{
					state2=false; //block the next while block
					state3=false; state4=false;
					String s= findDerivative(getVectorFrom(vector, 0, k-1)).concat("-").concat
					         (findDerivative(getVectorFrom(vector, k+1, vector.size()-1)) );
					return "(".concat(s).concat(")");
				}
				else{ k+=1; }

				if(k==vector.size()-1) state = false;

			}
			k=0;i=0;
			while(state2)//if + or - not detected in the first part this part will work
			{
				if(vector.get(k).equals("(")){ i+=1; k+=1;}
				else if(vector.get(k).equals(")")) {i-=1; k+=1;}
				else if(vector.get(k).equals("*")&& i==0)//...*...
				{
					state3=false; state4=false;
					Vector<String> term1 = getVectorFrom(vector, 0, k-1); //first term
					Vector<String> term2 = getVectorFrom(vector, k+1, vector.size()-1);//second term
					//s1=first*d(second)
					String s1="(".concat(vectorToString(term1)).concat(")").concat("*").concat("(")
					             .concat(findDerivative(term2)).concat(")");
					//s2= second *d(first)
					String s2="(".concat(vectorToString(term2)).concat(")").concat("*").concat("(")
								 .concat(findDerivative(term1)).concat(")");

					return "((".concat(s1).concat(")").concat("+").concat("(").concat(s2).concat("))");
				}
				else if(vector.get(k).equals("/")&& i==0)
				{
					state3=false; state4=false;
					Vector<String> num = getVectorFrom(vector, 0, k-1); //numerator and denomerator
					Vector<String> den = getVectorFrom(vector, k+1, vector.size()-1); // denomenator

					String s1 = vectorToString(den).concat("*").concat(findDerivative(num)) ;
					String s2 = vectorToString(num).concat("*").concat(findDerivative(den)) ;
					String s3 = "(".concat(vectorToString(den)).concat(")^2");

					return "(((".concat(s1).concat(")").concat("-").concat("(").concat(s2).concat("))/(").concat(s3).concat("))");
				}
				//else if
				else{ k+=1;}
				if(k==vector.size()-1) state2=false;

			}
			k=0;i=0;
			while(state3)//if * 0r / not detected in the first part this part will work
			{   //u^v
				if(vector.get(k).equals("(")){ i+=1; k+=1;}
				else if(vector.get(k).equals(")")) {i-=1; k+=1;}
				else if(vector.get(k).equals("^")&& i==0)//...*...
				{
					state4=false;
					Vector<String> term1 = getVectorFrom(vector, 0, k-1); //first term
					Vector<String> term2 = getVectorFrom(vector, k+1, vector.size()-1);//second term
					if(term2.size()==1&&isNumber(term2.get(0))&&!("x").equalsIgnoreCase(term2.get(0)))
					{
						double t2 = Double.valueOf(term2.get(0).trim()).doubleValue();
						String p   = Double.toString(t2);     //power
						String pm1 = Double.toString(t2-1); //power-1

						String s1 ="(".concat(p).concat("*").concat("(").concat(vectorToString(term1))
						             .concat("^").concat(pm1).concat("))");
						String s2 = findDerivative(term1);

						return  "(".concat(s1).concat("*").concat(s2).concat(")");
					}
					else{
					//s1=(first^second)
					String s1="((".concat(vectorToString(term1)).concat(")").concat("^").concat("(")
					             .concat(vectorToString(term2)).concat("))");
					//s2= (second*d(first)/first)
					String s2= "(((".concat(vectorToString(term2)).concat(")").concat("*").concat("(")
					                .concat(findDerivative(term1)).concat("))")
					                .concat("/").concat("(").concat(vectorToString(term1)).concat("))");
					//s3 = ln(first)*d(second)
					String s3= "(".concat("(ln(").concat(vectorToString(term1)).concat("))*(")
					              .concat(findDerivative(term2)).concat("))");
					String s4="(".concat(s2).concat("+").concat(s3).concat(")");

					String strin= "(".concat(s1).concat("*").concat(s4).concat(")");

					//fixing the ln part when multiplied by 0
					return strin;
				    }
				}

				//else if
				else{ k+=1;}
				if(k==vector.size()-1) state3=false;

			}
			k=0;i=0;
			while(state4)//if = or - not detected in the first part this part will work
			{
				if(vector.get(k).equalsIgnoreCase("sin"))//sin...-->cos
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "((cos(".concat(vectorToString(term)).concat("))").concat("*(")
					             .concat(findDerivative(term)).concat("))");
				}
				else if(vector.get(k).equalsIgnoreCase("cos"))//cos....-->-sin
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "((-sin(".concat(vectorToString(term)).concat("))").concat("*(")
					             .concat(findDerivative(term)).concat("))");
				}
				else if(vector.get(k).equalsIgnoreCase("tan"))//tan...--> sec square.
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "(((sec(".concat(vectorToString(term)).concat("))").concat("^2)").concat("*(")
					             .concat(findDerivative(term)).concat("))");
				}
				else if(vector.get(k).equalsIgnoreCase("cot"))//cot...-->-csc square
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "((-(csc(".concat(vectorToString(term)).concat("))").concat("^2)").concat("*(")
					             .concat(findDerivative(term)).concat("))");
				}
				else if(vector.get(k).equalsIgnoreCase("sec"))//sec...-->sec tan
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "(((sec(".concat(vectorToString(term)).concat("))")
					       .concat("*(tan(").concat(vectorToString(term)).concat(")))")
					       .concat("*(").concat(findDerivative(term)).concat("))");
				}
				else if(vector.get(k).equalsIgnoreCase("csc"))//csc...-->-csc cot
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "((-(csc(".concat(vectorToString(term)).concat("))")
					       .concat("*(cot(").concat(vectorToString(term)).concat(")))")
					       .concat("*(").concat(findDerivative(term)).concat("))");
				}
				else if(vector.get(k).equalsIgnoreCase("asin"))//asin..-->1/sqrt(1-x^2)
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "((1/(".concat("sqrt(").concat("1-((").concat(vectorToString(term))
					       .concat(")^2))))").concat("*(").concat(findDerivative(term)).concat("))");
				}
				else if(vector.get(k).equalsIgnoreCase("acos"))//acos..-->-1/sqrt(1-x^2)
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "((-1/(".concat("sqrt(").concat("1-((").concat(vectorToString(term))
					       .concat(")^2))))").concat("*(").concat(findDerivative(term)).concat("))");
				}
				else if(vector.get(k).equalsIgnoreCase("atan"))//atan..-->1/(1+x^2)
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "((1/".concat("(1+((").concat(vectorToString(term))
					       .concat(")^2)))").concat("*(").concat(findDerivative(term)).concat("))");
				}
				else if(vector.get(k).equalsIgnoreCase("asec"))//asec-->1/x*sqrt(x^2-1)
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "((1/((".concat(vectorToString(term)).concat(")*(sqrt(((")
					       .concat(vectorToString(term)).concat(")^2)-1))))")
					       .concat("*(").concat(findDerivative(term)).concat("))");
				}
				else if(vector.get(k).equalsIgnoreCase("exp"))//expx -->expx....
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "((exp(".concat(vectorToString(term)).concat("))*(")
					       .concat(findDerivative(term)).concat("))");
				}
				else if(vector.get(k).equalsIgnoreCase("ln"))//lnx-->1/x
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "((1/(".concat(vectorToString(term)).concat("))*(")
					       .concat(findDerivative(term)).concat("))");
				}
				else if(vector.get(k).equalsIgnoreCase("log"))//log-->1/(x*ln10)
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "((1/((".concat(vectorToString(term)).concat(")*(ln(10))))*(")
					       .concat(findDerivative(term)).concat("))");
				}
				else if(vector.get(k).equalsIgnoreCase("sqrt"))//sqrt-->1/(2*sqrtx)
				{
					state4=false;
					Vector<String> term = getVectorFrom(vector, k+1, vector.size()-1);
					return "((1/(2*(sqrt(".concat(vectorToString(term)).concat("))))")
					       .concat("*(").concat(findDerivative(term)).concat("))");
				}

				else{ k+=1;}
				if(k==vector.size()-1) state4=false;

			}


		}//else
         return" more rules";

	}//findDerivative(..)

    public static void main(String[ ] args)
	{
	  	Scanner sc = new Scanner(System.in);
	  	System.out.print("write down the Equation ");
	  	String equation =sc.nextLine();

	    DerivativeFinder df =new DerivativeFinder(equation);
	    df.print_stringTokens();

	    //System.out.println(answerFix(equation));


	    System.out.println("Derivative = "+findDerivative(df.get_stringTokens())+ "\n");

	  	Scanner sc2 = new Scanner(System.in);
	  	System.out.println("for x = ");
	  	String input =sc2.nextLine();
	  	double value = Double.valueOf(input.trim()).doubleValue();

	    Equation eq= new Equation(findDerivative(df.get_stringTokens()));
	    String x="x";
	    System.out.println("Derivative = "+eq.Evaluate(x, value)+ "\n");



	    //Vector<String> v = tokenize(equation);
	    //printVector(v);

	    //Vector<String> vec = new Vector<String>();
	    //vec.addElement("x");
	    //vec.addElement("+");
	    //vec.addElement("2");

	    //System.out.println(findDerivative(vec));

	    //Vector<String> vv = getVectorFrom(vec, 1,1);
	    //printVector(vv);

    }//main



}//class derivativeFinder